#!/usr/bin/env python

from math import log
from re import match
from os import listdir
import copy

loglist = listdir('./Logs')

runtime=[]
Dict = dict([('100',[]),('1000',[]),('10000',[]),('100000',[]),('1000000',[])])
PL=Dict.keys()
PL.sort()
print PL

runtime = [copy.deepcopy(Dict)]
rtMean = [copy.deepcopy(Dict)]
rtMin = [copy.deepcopy(Dict)]
for i in range(4):
	runtime.append(copy.deepcopy(Dict))
	rtMean.append(copy.deepcopy(Dict))
	rtMin.append(copy.deepcopy(Dict))

for logbook in loglist:
	NoP = 0
	Pl = 0
	logfile = open('Logs/' + logbook)
	res = match('logfile(\d+)\.(\d+)\-(\d+)\.log',logbook)
	NoP = int(log(int(res.group(1)),2)-1)
	Pl = res.group(3)
	runtime[NoP][Pl].append(float(logfile.readline()))

"Calculating Mean value and Minimum value of runtime for constant phaselength and Number of processes"
for i in range(5):
	for j in PL:
		rtMin[i][j] = min(runtime[i][j])
		rtMean[i][j] = (reduce(lambda x,y : (x+y),runtime[i][j],0))
		if (len(runtime[i][j]) > 1):
			rtMean[i][j] = rtMean[i][j]/(len(runtime[i][j])-1)
		else:
			rtMean[i][j] = rtMean[i][j]/(len(runtime[i][j]))

"Writing output"
output = open('outputAnalyse.m','w')
output.write('NoP = [ 2, 4, 8, 16, 32];\n')

output.write('PL = [ ')
for i in PL:
	if i == PL[0]:
		output.write('%d ' %int(i))
	else:
		output.write(', %d ' %int(i))
output.write('];\n')

output.write('%Mittelwerte der Bearbeitungszeiten in einer NoP times Phaselength Matrix\n')
output.write('%Spaltenindex durchlaeuft Phasenlaenge\n')
output.write('A = [')
for i in range(5):
	j=0
	output.write('%f ' %rtMean[i][PL[j]])
	for j in range(1,len(PL)-1):
		output.write('%f ' %rtMean[i][PL[j]])
	output.write('%f;\n' %rtMean[i][PL[-1]])

output.write('];\n')

output.write('%Minimalwerte der Bearbeitungszeiten in einer NoP times Phaselength Matrix\n')
output.write('%Spaltenindex durchlaeuft Phasenlaenge\n')
output.write('B = [')
for i in range(5):
	j=0
	output.write('%f ' %rtMin[i][PL[j]])
	for j in range(1,len(PL)-1):
		output.write('%f ' %rtMin[i][PL[j]])
	output.write('%f;\n' %rtMin[i][PL[-1]])

output.write('];\n')

output.close()
