#include <stdio.h>
#include <malloc.h>
#include <math.h>
#include "common/basemod.h"

int main(int argc, char** argv){
	int i,j; /*loopvariables*/
	int *sudoku,*pos;
	int size,bs,freeFields,stat[4],splcnt[4],status;
	subtree_t Tree[4];
	for(i=0;i<4;i++)
		splcnt[i] = 0;

	/* read in sudoku*/
	scanf("%d\n",&size);
	sudoku = (int*)malloc(sizeof(int)*size*size);
	for(i=0;i<size;i++){
		for(j=0;j<size;j++){
			scanf("%d\t",&sudoku[size*i+j]);
		}
	}

	for(i=0;i<4;i++)
		subtree_init(&(Tree[i]), size, sudoku);

	subtree_split(&Tree[1],&Tree[2]);
	subtree_split(&Tree[1],&Tree[3]);
	subtree_split(&Tree[2],&Tree[4]);


	/*solving the sudoku*/
	for(i=0;i<4;i++)
		stat[i] = subtree_work(&Tree[i]);

	while(1){
		for(i=0;i<4;i++)
			stat[i] = subtree_work(&Tree[i]);

		/*check solved*/
		status = 0;
		for(i=0;i<4;i++)
			status |= (stat[i] == PB_SOLVED);

		if(status){
			printf("Solution found:\n");
			for(i=0;i<4;i++)
				subtree_print(&Tree[i]);
			printf("Splitcount:\n");
			for(i=0;i<4;i++)
				printf("splcnt[%d]: %d\n",i,splcnt[i]);
			break;
		}

		/* check unsolvable*/	
		status = 0;
		for(i=0;i<4;i++)			
			status &= (stat[i] == PB_EMPTY);

		if(status){
			printf("Sudoku unsolvable\n");
			break;
		}

		for(i=0;i<4;i++)
			if(stat[i] == PB_EMPTY){
				subtree_split(&Tree[(i+1)%4],&Tree[i]);
				splcnt[i]++;
			}
	}

	for(i=0;i<4;i++)
		subtree_destroy(&Tree[i]);
	free(sudoku);
}
